--- old/usr/src/cmd/psrinfo/psrinfo.c	Thu Dec  6 15:01:42 2012
+++ new/usr/src/cmd/psrinfo/psrinfo.c	Thu Dec  6 15:01:42 2012
@@ -11,6 +11,7 @@
 
 /*
  * Copyright (c) 2012 DEY Storage Systems, Inc.  All rights reserved.
+ * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /*
@@ -97,6 +98,7 @@
 	long		v_pchip_id;	/* 1 per socket */
 	char		*v_impl;
 	char		*v_brand;
+	char		*v_socket;
 	long		v_core_id;	/* n per chip_id */
 };
 
@@ -268,6 +270,9 @@
 			if (((len = strlen(vcpu->v_brand)) != 0) &&
 			    (strncmp(vcpu->v_brand, vcpu->v_impl, len) != 0))
 				(void) printf("\t%s", vcpu->v_brand);
+			if (strcmp(vcpu->v_socket, "Unknown") != 0)
+				(void) printf("\t[ %s: %s ]", _("Socket"),
+				    vcpu->v_socket);
 			(void) putchar('\n');
 		} else {
 			for (l2 = chip->p_cores; l2; l2 = l2->l_next) {
@@ -507,6 +512,12 @@
 			vc->v_brand = mystrdup(knp->value.str.addr.ptr);
 		}
 
+		if ((knp = kstat_data_lookup(ksp, "socket_type")) == NULL) {
+			vc->v_socket = "Unknown";
+		} else {
+			vc->v_socket = mystrdup(knp->value.str.addr.ptr);
+		}
+
 		if ((knp = kstat_data_lookup(ksp, "implementation")) == NULL) {
 			vc->v_impl = _("(unknown)");
 		} else {
